#include <bits/stdc++.h>

using namespace std;

vector<int> osztoimeg(int n)
{
    vector<int> osztoi;

    for(int i=1;i<=n;i++)
    {
        if(n%i==0)
            osztoi.push_back(i);
    }

    return osztoi;
}




int main()
{

    int n, k;
    cin>>n>>k;

    vector<int> osztok(k);
    for(int i=0;i<k;i++)
    {
        cin>>osztok.at(i);
    }

    for(int i=0;i<k;i++)
    {
        int szam=osztok.at(i);

        vector<int> osztoi=osztoimeg(szam);

        int ertek=osztoi.at(0);

        for(int j=1;j<osztoi.size();j++)
        {
             ertek=ertek^osztoi.at(j);

        }
        cout<<ertek<<" ";
    }




    return 0;
}